import mt.deepnight.slb.*;
import mt.deepnight.slb.assets.TexturePacker;
import mt.flash.Sfx;

class Assets {
	public static var tiles		: mt.deepnight.slb.BLib;

	public static var SBANK = Sfx.importDirectory("assets/sounds");

	public static var music : Sfx;

	public static function init() {
		tiles = TexturePacker.importXml("assets/tiles.xml");
		tiles.defineAnim("heroWalk", "0(4),1-7(3)");
		tiles.defineAnim("heroWalkGun", "0(4),1-7(3)");
		tiles.defineAnim("heroIdleA", "0-1(50)");
		tiles.defineAnim("heroIdleB", "0-1(60)");
		tiles.defineAnim("heroBackToIdleGun", "0(2)");
		tiles.defineAnim("heroCrouching", "0-1(2)");
		tiles.defineAnim("heroCrouchingNoGun", "0-1(2)");
		tiles.defineAnim("copCrouching", "0-1(2)");
		tiles.defineAnim("targetWalk", "0-7(3)");

		Sfx.setChannelVolume(0, 1.0);
		Sfx.setChannelVolume(1, 0.35);
		music = SBANK.ld32();
		music.setChannel(1);
	}

	public static function createField(txt:Dynamic, ?col=0xFFFFFF, ?maxWid=-1.) {
		//var f = new flash.text.TextFormat("assets.px_sans_nouveaux.ttf", 8, col);
		var f = new flash.text.TextFormat("assets.04B_03__.TTF", 8, col);
		var tf = new flash.text.TextField();
		tf.setTextFormat(f);
		tf.embedFonts = true;
		tf.defaultTextFormat = f;
		//tf.antiAliasType = flash.text.AntiAliasType.ADVANCED;
		tf.mouseEnabled = tf.selectable = false;
		var ml = maxWid>0;
		tf.wordWrap = tf.multiline = ml;
		tf.text = Std.string(txt);
		if( ml ) {
			tf.width = maxWid;
			tf.height = 300;
		}
		tf.width = tf.textWidth+5;
		tf.height = tf.textHeight+5;
		return tf;
	}
}
