import flash.display.BlendMode;
import flash.display.Sprite;
import flash.display.Bitmap;
import flash.display.BitmapData;

import mt.MLib;
import mt.deepnight.Particle;
import mt.deepnight.Tweenie;
import mt.deepnight.Lib;
import mt.deepnight.Color;

import Const;

class Fx extends mt.deepnight.Process {
	public static var ME : Fx;

	var game(get,never)	: Game;
	var pt0				: flash.geom.Point;

	public function new() {
		super(Game.ME);
		ME = this;

		pt0 = new flash.geom.Point(0,0);

	}

	function get_game() return Game.ME;

	override function unregister() {
		super.unregister();
		Particle.clearAll();
	}

	inline function get_time() return Game.ME.time;

	public function register(p:Particle, ?add=true) {
		game.sdm.add(p, Const.DP_FX);
		p.blendMode = add ? BlendMode.ADD : BlendMode.NORMAL;
	}

	public function registerBg(p:Particle, ?add=true) {
		game.sdm.add(p, Const.DP_BG_FX);
		p.blendMode = add ? BlendMode.ADD : BlendMode.NORMAL;
	}

	public function cars(xmin,xmax, y, dir:Int) {
		var p = new mt.deepnight.Particle(rnd(xmin,xmax), y+rnd(0,2,true));
		p.drawBox(rnd(4,6), rnd(2,3), 0x341b30);
		p.filters = [
			new flash.filters.BlurFilter(2,2),
		];
		p.fadeIn(rnd(0.5, 0.8), 0.02);
		p.life = rnd(50,90);
		p.dx = rnd(0.2, 0.5)*dir;
		p.bounds = new flash.geom.Rectangle(xmin, y-50, xmax-xmin, 100);
		p.fadeOutSpeed = 0.02;

		registerBg(p, false);
	}

	public function dust() {
		var x = -game.scroller.x;
		var y = -game.scroller.y;
		var p = new mt.deepnight.Particle(x+rnd(0,game.buffer.width), y+rnd(0,game.buffer.height));
		p.drawBox(1,1, 0x677252);
		p.filters = [
			new flash.filters.GlowFilter(0x677252,rnd(0.1,0.2), 4,4,50),
		];
		p.fadeIn(rnd(0.1, 0.4), 0.02);
		p.life = rnd(50,90);
		p.gx = rnd(0.03, 0.06);
		p.gy = rnd(-0.005,0.030);
		p.frict = rnd(0.96, 0.99);
		p.fadeOutSpeed = 0.02;

		registerBg(p, true);
	}


	public function blink(col:UInt, ?duration=1.0, ?pow=1.0) {
		var p = new mt.deepnight.Particle(0,0);
		var bd = new flash.display.BitmapData(10,10, true, mt.deepnight.Color.addAlphaF(col,0.6*pow));
		p.useBitmapData(bd, true, 0,0);
		p.width = game.buffer.width;
		p.height = game.buffer.height;
		p.life = 0;
		p.fadeOutSpeed = 0.06/duration;
		p.blendMode = ADD;
		game.buffer.dm.add(p, Const.DP_FX);
	}


	public function shinePoi(p:Poi) {
		//var a = 6.28 * (time%20)/20;
		//var p = new mt.deepnight.Particle(p.x+p.wid*0.5 + Math.cos(a)*8+rnd(0,1,true), p.y+p.hei*0.5 + Math.sin(a)*8+rnd(0,1,true));
		var p = new mt.deepnight.Particle(p.centerX+rnd(0,3,true), p.centerY+rnd(0,3,true));
		p.drawBox(1, 1, 0x4893B7);
		p.fadeIn(rnd(0.7,1),0.2);
		p.filters = [ new flash.filters.GlowFilter(0x4893B7,0.5, 4,4,3) ];
		p.gy = -rnd(0.01,0.03);
		p.life = rnd(2,5);
		registerBg(p);
	}


	var cdir = true;
	public function cigSmoke(x,y) {
		if( time%10!=0 )
			return;

		cdir = !cdir;
		var p = new mt.deepnight.Particle(x+rnd(0,1),y+rnd(0,1,true));
		p.useBitmapData(Assets.tiles.getBitmapDataRandom("cigSmoke"), true, 0.5,1);
		p.fadeIn(rnd(0.1,0.3), 0.03);
		p.dy = -rnd(0, 0.3);
		p.scaleY = rnd(0.5,1);
		p.scaleX = rnd(0.5,1) * (cdir?1:-1);
		p.frict = 0.95;
		p.life = rnd(10,30);
		register(p);
	}



	public function cigHeat(x,y) {
		x = Std.int(x);
		y = Std.int(y);
		var c = Color.makeColorHsl(rnd(0,0.2), 1,1);
		var p = new mt.deepnight.Particle(x,y);
		p.drawBox(1,1, c, 1);
		p.filters = [
			new flash.filters.GlowFilter(0xFF0000,0.4, 4,4,20),
		];
		p.fadeIn(rnd(0.1,0.4), 0.2);
		p.life = rnd(2,5);
		register(p);
	}



	public function hit(from:Entity, e:Entity, col:UInt) {
		// Explosion
		var p = new mt.deepnight.Particle(e.xx+rnd(0,3,true),e.yy-25+rnd(0,5,true));
		p.drawCircle(3,col,1);
		p.ds = 0.3;
		p.life = 2;
		p.filters = [
			new flash.filters.GlowFilter(col,0.3, 8,8,20),
			new flash.filters.GlowFilter(col,0.8, 32,32),
		];
		register(p);

		var dir = from.xx>e.xx ? 1 : -1;


		// Blood back
		for(i in 0...20) {
			var p = new mt.deepnight.Particle(e.xx+rnd(0,3,true),e.yy-25+rnd(0,3,true));
			p.drawBox(rnd(1,3), 1,col,1);
			p.filters = [
				new flash.filters.GlowFilter(col,0.1, 4,4,20),
			];
			var a = (dir==1?3.14:0) + rnd(0,0.2,true);
			p.moveAng( a, rnd(2,15) );
			p.rotation = MLib.toDeg(a);
			p.frict = 0.93;
			p.life = rnd(5,20);
			register(p);
		}
	}


	public function dead(e:Entity) {
		// Body
		var p = new mt.deepnight.Particle(e.xx+rnd(0,3,true),e.yy-25+rnd(0,5,true));
		p.useBitmapData( Assets.tiles.getBitmapData("dead"), true );
		p.dx = -e.dir*5;
		p.dy = -2;
		p.gy = 0.2;
		p.scaleX = e.dir;
		p.dr = -2*e.dir;
		p.frict = 0.9;
		p.dsy = -0.02;
		p.onUpdate = function() {
			p.dr*=0.9;
			p.gy*=0.9;
		}
		p.filters = [ new flash.filters.GlowFilter(0xFF9300,0.8, 16,16,2) ];
		p.life = 20;
		register(p);

		// Body dots
		for(i in 0...35) {
			var p = new mt.deepnight.Particle(e.xx+rnd(0,5,true),e.yy-25+rnd(0,15,true));
			p.drawBox(2, 2,0xFFFF80,1);
			p.filters = [
				new flash.filters.GlowFilter(0xFF9300,0.1, 4,4,20),
			];
			p.dx = -e.dir*rnd(4,8);
			p.dy = -2;
			p.gy = rnd(0.05, 0.2);
			p.scaleX = e.dir;
			p.frict = rnd(0.90,0.95);
			//p.onUpdate = function() {
				//if( Scene.CURRENT.hasCollision( Std.int(p.x/Const.GRID), Std.int(p.y/Const.GRID) ) )
					//p.groundY = p.y;
			//}
			p.life = rnd(20,35);
			register(p);
		}

		// Blood back
		for(i in 0...20) {
			var p = new mt.deepnight.Particle(e.xx+rnd(0,3,true),e.yy-25+rnd(0,3,true));
			p.drawBox(rnd(1,3), 1,0xFFFF80,1);
			p.filters = [
				new flash.filters.GlowFilter(0xFF9300,0.1, 4,4,20),
			];
			var a = (e.dir==1?3.14:0) + rnd(0,0.2,true);
			p.moveAng( a, rnd(2,15) );
			p.rotation = MLib.toDeg(a);
			p.frict = 0.93;
			p.life = rnd(5,20);
			register(p);
		}
	}


	public function shield(x:Float,y:Float, col) {
		var p = new mt.deepnight.Particle(x+rnd(0,1,true), y-rnd(3,20));
		p.drawBox(1, rnd(2,6), col, rnd(0.3,0.6));
		p.filters = [ new flash.filters.GlowFilter(col,0.3, 4,4,2) ];
		p.life = rnd(4,8);
		register(p);
	}


	public function shake(pow:Float, frames:Int) {
		var d = frames;
		createTinyProcess(function(p) {
			game.buffer.render.y = Math.cos(time*10)* (frames/d)*pow*5;
			frames--;
			if( frames<=0 ) {
				game.buffer.render.y = 0;
				p.destroy();
			}
		});
	}

	public function surprise(e:Entity) {
		var p = new mt.deepnight.Particle(e.xx, e.yy-20);
		p.useBitmapData( Assets.tiles.getBitmapData("surprise"), true, 0.5,1 );
		p.dx = 0.5;
		p.dy = -4;
		p.frict = 0.8;
		p.life = 30;
		register(p);
	}

	public function bigTitle(str:String, col:UInt) {
		blink(col, 1.5);

		var s = new flash.display.Sprite();
		game.buffer.dm.add(s, Const.DP_UI);
		var tf = Assets.createField(str.toUpperCase(), col);
		s.addChild(tf);
		tf.scaleX = tf.scaleY = 4;
		tf.blendMode = ADD;
		tf.x = Std.int( -tf.textWidth*tf.scaleX*0.5 );
		tf.y = Std.int( -tf.textHeight*tf.scaleY*0.5 );
		tf.filters = [	new flash.filters.GlowFilter(col, 0.8, 32,32,1) ];

		s.x = Std.int( game.buffer.width*0.5 );
		s.y = Std.int( game.buffer.height*0.5 );
		s.scaleX = s.scaleY = 3;

		tw.create(s.alpha, 1, 200);
		tw.create(s.scaleX, 1, TEaseIn, 300).onUpdate = function() {
			s.scaleY = s.scaleX;
		}

		createTinyProcess(function(p) {
			if( p.time>=50 ) {
				s.alpha-=0.02;
				if( s.alpha<=0 ) {
					p.destroy();
					s.parent.removeChild(s);
				}
			}
		});
	}


	public function dot(x:Float,y:Float, col, d:Int) {
		if( time%d!=0 )
			return;

		var p = new mt.deepnight.Particle(x,y);
		p.drawBox(1, 1, col);
		p.fadeIn(1,0.2);
		p.filters = [ new flash.filters.GlowFilter(col,0.8, 4,4,10) ];
		p.life = d*0.6;
		registerBg(p);
	}

	public function announceShoot(x:Float,y:Float, col) {
		var p = new mt.deepnight.Particle(x,y);
		p.drawBox(1, 1, col);
		p.fadeIn(1,0.2);
		p.filters = [ new flash.filters.GlowFilter(col,0.5, 4,4,3) ];
		p.life = 5;
		register(p);
	}



	public function laser(x:Float,y:Float, dir:Int, col:UInt) {
		// Line
		var p = new mt.deepnight.Particle(x, y+rnd(0,1,true));
		p.graphics.beginFill(col);
		p.graphics.drawRect(0, 0, 130, 1);
		var a = dir==1?0:3.14;
		a+=rnd(0,0.03,true);
		p.rotation = MLib.toDeg(a);
		var once = false;
		p.onUpdate = function() {
			if( !once ) {
				once = true;
				p.moveAng(a, 20);
			}
		}
		p.life = 2;
		p.filters = [
			new flash.filters.GlowFilter(col,0.3, 4,4,20),
			new flash.filters.GlowFilter(col,0.8, 16,16),
		];
		register(p);

		// Explosion
		var p = new mt.deepnight.Particle(x+rnd(0,1,true),y+rnd(0,0,true));
		p.drawCircle(2,col,1);
		p.ds = 0.2;
		p.life = 1;
		p.filters = [
			new flash.filters.GlowFilter(col,0.3, 8,8,20),
			new flash.filters.GlowFilter(col,0.8, 32,32),
		];
		register(p);

		// Explosion 2
		var p = new mt.deepnight.Particle(x+dir*8+rnd(0,1,true),y+rnd(0,0,true));
		//p.drawCircle(2,col,1);
		p.drawBox(rnd(5,10),1, col);
		//p.ds = 0.1;
		p.moveAng(a,10);
		p.delay = 2;
		p.life = 1;
		p.filters = [
			new flash.filters.GlowFilter(col,0.3, 8,8,20),
			//new flash.filters.GlowFilter(col,0.8, 32,32),
		];
		register(p);

		// Halo
		var p = new mt.deepnight.Particle(x+rnd(0,2,true),y+rnd(0,1,true));
		p.drawCircle(50,col,0.05);
		p.ds = -0.05;
		p.life = 0;
		register(p);
	}

	override function update() {
		super.update();
		Particle.update();
	}
}


