package en;

import mt.MLib;
import mt.deepnight.slb.*;
import mt.deepnight.Lib;
import mt.flash.Key;
import flash.ui.Keyboard;

class Cop extends Entity {
	public static var ALL : Array<Cop> = [];
	public function new(x,y, l) {
		super();

		ALL.push(this);

		spr.a.registerStateAnim("copHit", 10, function() return cd.has("hit"));
		spr.a.registerStateAnim("copCrouch", 1, function() return crouch);
		spr.a.registerStateAnim("copIdle", 0);
		spr.a.applyStateAnims();
		spr.filters = [
			new flash.filters.GlowFilter(0x27132F,1, 2,2,3),
			new flash.filters.DropShadowFilter(4,0, 0x0,0.4, 0,0,1),
		];

		initLife(l);
		setPosCase(x,y);
		dir = -1;
		cd.set("shoot", Const.seconds(0.7));
	}

	public static function clear() {
		for(e in ALL)
			e.destroy();
	}

	override function unregister() {
		super.unregister();
		ALL.remove(this);
	}

	override function onDie() {
		super.onDie();

		Assets.SBANK.death2(1);
		destroy();
		Game.ME.cd.set("copDeath", Const.seconds(1));
		Fx.ME.shake(1,20);
	}

	override function hit() {
		super.hit();
		Assets.SBANK.kick3(1);
		if( !isDead() ) {
			dx+=0.2*(Game.ME.hero.xx<xx ? 1 : -1);
			cd.set("hit", 5);
			if( cd.has("visible") )
				cd.set("visible", cd.get("visible")*0.5);
		}
	}

	override function update() {
		super.update();
		var col = 0x1E89E1;

		dir = Game.ME.hero.xx>xx ? 1 : -1;

		if( !scene.locked && !Game.ME.hero.isDead() ) {
			// Reveal to shoot
			if( !cd.has("shoot") && !cd.has("aiming") ) {
				cd.set("aiming", Const.seconds(rnd(0.3,1)));
				cd.onComplete("aiming", function() {
					// Shoot!
					Assets.SBANK.lazer1(rnd(0.1,0.3));
					Fx.ME.laser(xx+dir*14,yy-30, dir, col);
					cd.set("shoot", Const.seconds(rnd(2,4)));
					var h = Game.ME.hero;
					if( MLib.fabs(h.xx-xx)<=200 && !h.crouch && (dir==1 && h.xx>xx || dir==-1 && h.xx<xx) ) {
						Fx.ME.hit(this, h, col);
						h.hit();
					}

				});
				cd.set("visible", cd.get("aiming") + Const.seconds(rnd(0.2,2)));
			}

			if( cd.has("aiming") && cd.get("aiming")<=10 )
				Fx.ME.announceShoot(xx+dir*14, yy-30, col);

			if( !crouch && !cd.has("visible") ) {
				crouch = true;
				spr.a.play("copCrouching");
			}
			if( crouch && cd.has("visible") )
				crouch = false;
		}

		if( crouch )
			Fx.ME.shield(xx+dir*13, yy, col);
	}
}
