package en;

import mt.MLib;
import mt.deepnight.slb.*;
import mt.deepnight.Lib;
import mt.flash.Key;
import flash.ui.Keyboard;

class Hero extends Entity {
	var idle			: String;
	public var combat	: Bool;

	public function new() {
		super();

		//spr.graphics.beginFill(0x0080FF);
		//spr.graphics.drawRect(-5,-Const.GRID*1.7,10,Const.GRID*1.7);
		idle = "A";
		combat = false;

		//combat = crouch = true; dir = -1;

		spr.a.registerStateAnim("heroHit", 12, function() return cd.has("hit"));
		spr.a.registerStateAnim("heroJumpUp", 11, function() return dy<-0.05);
		spr.a.registerStateAnim("heroJumpDown", 10, function() return !stable);
		spr.a.registerStateAnim("heroWalkGun", 5, function() return !crouch && combat && isWalking());
		spr.a.registerStateAnim("heroWalk", 4, function() return !crouch && !combat && isWalking());
		spr.a.registerStateAnim("heroCrouchNoGun", 3, function() return crouch && !combat);
		spr.a.registerStateAnim("heroCrouch", 3, function() return crouch && combat);
		spr.a.registerStateAnim("heroShootIdle", 2, function() return combat);
		spr.a.registerStateAnim("heroIdleB", 1, function() return idle=="B");
		spr.a.registerStateAnim("heroIdleA", 0);
		//spr.a.registerStateAnim("heroWalk", 0);
		spr.a.applyStateAnims();
		spr.filters = [
			new flash.filters.GlowFilter(0x27132F,1, 2,2,3),
			new flash.filters.DropShadowFilter(4,0, 0x0,0.4, 0,0,1),
			//new flash.filters.DropShadowFilter(3,180, 0x0,0.25, 2,2,1),
		];

		initLife(3);

		setPosCase(0,0);
	}

	override function hit() {
		super.hit();
		Assets.SBANK.hit2(1);
		Fx.ME.blink(0xFF0000);
		if( !isDead() ) {
			dx+=0.2*(-dir);
			cd.set("hit", 5);
		}
	}

	override function onDie() {
		super.onDie();

		Assets.SBANK.death1(0.3);
		ui.TutorialMsg.clearAll();
		spr.visible = false;
		Fx.ME.bigTitle("Busted!", 0xFF0000);
		Fx.ME.shake(1, 30);
		scene.locked = true;
		Game.ME.delayer.add( Scene.reload, 2000 );
	}

	override function onEndFrame() {
		super.onEndFrame();
	}

	override function unregister() {
		super.unregister();
	}

	public function setCombat(v:Bool) {
		if( combat==v )
			return;

		combat = v;
		if( combat && !crouch )
			spr.a.play("heroBackToIdleGun");
		life = maxLife;
		updateLifeBar();
	}

	function shoot() {
		mt.flash.Sfx.playOne([
			Assets.SBANK.lazer2,
			Assets.SBANK.lazer3,
		], rnd(0.2,0.3));
		spr.a.play("heroShoot");
		spr.a.setCurrentAnimSpeed(0.3);
		Fx.ME.laser(xx+dir*14,yy-27, dir, 0xFF0000);
		cd.set("shoot", Const.seconds(0.3));
		cd.set("move", Const.seconds(0.4));
		dx = 0;

		var x = cx;
		var d = 15;
		while( d>0 ) {
			x+=dir;
			for( e in en.Cop.ALL )
				if( !e.crouch && e.cx==x && MLib.iabs(e.cy-cy)<=2 ) {
					Fx.ME.hit(this, e, 0xFF0000);
					e.hit();
					d = 0;
					break;
				}
			d--;
		}
	}

	public function isPressingMoveKeys() {
		return Key.isDown(Key.LEFT) || Key.isDown(Key.RIGHT);
	}

	override function update() {
		var wasWalking = isWalking();
		super.update();

		if( combat && !crouch && !isWalking() && wasWalking && stable )
			spr.a.play("heroBackToIdleGun");

		// Idle
		if( !cd.has("idleChange") ) {
			idle = idle=="A"?"B":"A";
			cd.set("idleChange", Const.seconds(rnd(2,4)));
		}

		// Cigaret fx
		if( spr.visible )
			switch( spr.groupName ) {
				case "heroShootIdle" :
					if( time%10==0 )
						Fx.ME.cigHeat(xx + (dir==-1?-1:0), yy-27);
				case "heroIdleA" :
					if( spr.frame==0 )
						Fx.ME.cigSmoke(xx+dir*6,yy-27);
					else
						Fx.ME.cigSmoke(xx+dir*6,yy-24);

				case "heroCrouch" :
					Fx.ME.cigSmoke(xx+dir*7,yy-10);

				case "heroCrouchNoGun" :
					Fx.ME.cigSmoke(xx+dir*11,yy-10);

				case "heroIdleB" :
					if( spr.frame==0 ) {
						Fx.ME.cigHeat(xx+dir*2 + (dir==-1?-1:0), yy-29);
						Fx.ME.cigSmoke(xx+dir*3,yy-29);
					}
					else
						Fx.ME.cigSmoke(xx+dir*7,yy-20);
			}

		//if( spr.a.isPlayingAnim("heroIdleA") && !cd.has("head") ) {
			//cd.set("head", Const.seconds(rnd(1,2)));
		//}

		// Controls
		if( ui.Menu.CURRENT!=null ) {
			// Menu
			var m = ui.Menu.CURRENT;
			if( Key.isToggled(Key.UP) )
				m.prev();
			if( Key.isToggled(Key.DOWN) )
				m.next();
			if( Key.isDown(Key.ESCAPE) )
				m.close();
			if( Key.isToggled(Key.SPACE) || Key.isToggled(Key.ENTER) )
				m.confirm();
		}
		else if( ui.Pop.ALL.length>0 ) {
			// Pop up message
			if( Key.isToggled(Key.ESCAPE) || Key.isToggled(Key.SPACE) || Key.isToggled(Key.ENTER) )
				ui.Pop.closeAll();
		}
		else if( !scene.locked ) {
			// Movements
			//var s = 0.018;
			var s = 0.03;
			if( !cd.has("move") ) {
				if( Key.isDown(Key.LEFT) ) {
					dir = -1;
					if( !crouch )
						dx-=s;
				}
				if( Key.isDown(Key.RIGHT) ) {
					dir = 1;
					if( !crouch )
						dx+=s;
				}
				if( combat && !crouch && Key.isDown(Key.DOWN) && stable ) {
					crouch = true;
					spr.a.play("heroCrouching");
				}
			}
			if( !combat && !crouch && Key.isDown(Key.DOWN) && stable ) {
				crouch = true;
				spr.a.play("heroCrouchingNoGun");
			}

			if( stable && Key.isToggled(Key.UP) ) {
				if( crouch )
					crouch = false;
				//else if( !combat )
					//dy = -0.45;
			}

			#if debug
			if( Key.isToggled(Keyboard.C) ) {
				cd.set("forceCombat", 99999);
				setCombat(!combat);
			}
			#end

			if( stable && Key.isToggled(Key.SPACE) ) {
				if( combat && !crouch && !cd.has("shoot") )
					shoot();

				if( !combat )
					Game.ME.activate(xx,yy);
			}
		}

		if( mt.flash.Sfx.isChannelMuted(1) && isWalking() && stable && !cd.has("step") ) {
			cd.set("step", 13);
			Assets.SBANK.step1(rnd(0.03, 0.09));
		}

		if( crouch && combat )
			Fx.ME.shield(xx+dir*13, yy, 0xFF0000);

		if( !scene.locked && combat && en.Cop.ALL.length==0 && !Game.ME.cd.has("copDeath") && !cd.has("forceCombat") ) {
			scene.onCombatEnd();
			setCombat(false);
		}
	}
}