package sc;

import mt.deepnight.slb.*;
import mt.MLib;

class Apartment extends Scene {
	var dark			: BSprite;
	var door			: BSprite;

	public function new() {
		super();

		id = "apartment";
		read("l_apartment");
		Game.ME.hero.setPosCase(20,9, 1);

		door = Assets.tiles.get("bathDoor");
		Game.ME.sdm.add(door,Const.DP_BG);
		door.setPos(433,120);
		door.visible = !has("aptAssault");

		#if debug
		//set("aptAssault");
		//set("sabotageFridge");
		//set("sabotageRice");
		//set("sabotageDoor");
		set("item_Constipation pills");
		#end


		new Poi("Light switch", 260,141)
			.look( function() g.say(">High technology: you press it, it turns the light on. It can even control multiple lights.") )
			.use( function() {
				if( toggle("light1") ) {
					if( !hasSet("aptAssault") ) {
						locked = true;
						function _tuto() {
							new ui.TutorialMsg("combat1", "UP: stand  DOWN:cover", 249,50);
							new ui.TutorialMsg("combat2", "SPACE:shoot", 270,65);
						}
						var e : en.Cop = null;
						function _cop() {
							e = new en.Cop(27,9, 2);
						}
						cm.create({
							500;
							hero.dir = 1;
							300;
							g.say("As you turn on the light, you hear a noise coming from the bathroom...") > end;
							500;
							_cop();
							hero.setCombat(true);
							500>>Fx.ME.surprise(e);
							300>>tw.create(door.scaleX, 0, 1200);
							300;
							g.say("!>Shit, a cop!") > end;

							g.say("Press UP to stand, DOWN to cover.") > end;
							100;
							hero.crouch = true;
							200;

							g.say("SPACE to shoot (only while standing).") > end;

							100;
							_tuto();
							locked = false;
						});
					}
				}
			});

		new Poi("Exit", 331,136)
			.use( function() {
				transition( function() new sc.Balcony() );
			});

		new Poi("Bed", 474,148)
			.look( function() {
				cm.create({
					g.say("The bed looks really comfy. You notice a woman perfume.")>end;
					if( !foundItem("Small key") )
						g.say(">There is small white key near the pillow.")>end;
				});
			})
			.use( function() {
				if( !foundItem("Small key") ) {
					addItem("Small key");
					g.say("You pick a small key lying near the pillow.");
				}
				else
					g.say(">No! Who knows what happened in this bed?");
			});

		new Poi("Bathroom", 433,139)
			.use( function() {
				transition( function() new sc.Bathroom() );
			});

		new Poi("Microwave", 249,140)
			.look( function() g.say(">It would be very useful if my next contract was a hamster.") );

		new Poi("Clothes", 404,157)
			.look( function() {
				g.say([">A pile of shirts is lying on the ground. Typical."]);
			})
			.use( function() g.say(">It's too large for me and it probably stinks.") );

		new Poi("Table", 290,142)
			.look( function() g.say([">Rice, chicken, coffe. Two cups.", ">It's cold."]) )
			.use( function() {
				cm.create({
					g.say("The meal is probably one or two days old. But I won't bother checking it myself.") > end;
					if( !foundItem("Knife") ) {
						addItem("Knife");
						g.say("You find a knife on the table. Not sharp enough to kill someone, but it could be useful.");
					}
				});
			})
			.useWith( function(i) {
				if( i=="Constipation pills" )
					g.say("!It's ALREADY a bad idea to eat this old chicken... I don't need to poison it.");
				return false;
			});

		new Poi("Huge fridge", 201,138)
			.look( function() {
				if( has("sabotageFridge") )
					g.say([">So much food, so much diarrhea."]);
				else
					g.say([">My target has stored enough food for a month inside this fridge."]);
			})
			.use( function() {
				cm.create({
					if( has("sabotageFridge") )
						g.say([">I definitely won't eat anything from this fridge now!"]);
					else
						g.say(">Tempting. I could have a snack, but I don't think I have the time for that.") > end;
				});
			})
			.useWith( function(i) {
				if( i=="Constipation pills" ) {
					if( !has("sabotageFridge") ) {
						g.say("You pour powdered pills on everything in the fridge.");
						set("sabotageFridge");
						removeItem("Constipation pills");
						return true;
					}
					g.say("!You already poisoned everything here.");
				}
				return false;
			});

		new Poi("Sink", 227,141)
			.look( function() g.say(["The sink was meticulously scoured recently."]) )
			.use( function() {
				g.say(">I don't need water.");
			});

		new Poi("Rustic wardrobe", 378,143)
			.look( function() g.say([">This closet must be really expensive. And it's large enough to hide a body, which is always a good thing."]) )
			.use( function() {
				g.say("You inspect the clothes but find nothing of interest.");
			});

		if( cameFrom("bathroom") ) {
			hero.setPosCase(27,9, -1);
			if( !hasSet("copBoss") ) {
				locked = true;
				new en.Cop(19,9, 6);
				cm.create({
					500;
					g.say(">Ahhh come on.")>end;
					hero.setCombat(true);
					locked = false;
				});
			}
		}
		else {
			#if !debug
			if( !hasSet("briefing") ) {
				locked = true;
				cm.create({
					hero.dir = -1;
					500;
					g.say("!>I can't kill my target with my gun. Hmm...") > end;
					hero.dx = -0.15;
					800;
					hero.dir = 1;
					100;
					g.say(">I guess I could lock him inside its own apartment and let him die from starvation?") > end;
					hero.dir = -1;
					g.say(">I'll just have to poison the food and lock all the exits.") > end;
					500;
					g.say("!>Sounds like the worst plan I ever had.") > end;
					g.say(">Let's do it.") > end;
					locked = false;
				});
			}
			#end
		}


		#if debug
		//set("light1");
		#end

		checkEnd();
	}

	function checkEnd() {
		if( objectiveComplete() )
			if( !cd.hasSet("end", 999999) ) {
				locked = true;
				cm.create({
					g.say(">Everything is ready.") > end;
					g.say(">Let's wait for my guest outside.")>end;
					hero.goto(329)>end;
					transition( function() new sc.Balcony() );
				});
			}
	}


	override function onCombatEnd() {
		super.onCombatEnd();

		if( !hasSet("firstVictory") ) {
			ui.TutorialMsg.clear("combat1");
			ui.TutorialMsg.clear("combat2");
			g.say([
				">!Ah ah! Take that!",
				">Being badass with a gun: CHECK.",
				">This was not my target. Strange.",
			]);
		}
		else {
			g.say([
				">So much for the Stealth approach.",
				">Too bad I forgot my grenades.",
			]);
		}
	}


	override function draw() {
		super.draw();

		bg = Assets.tiles.get("s_apartment");
		Game.ME.sdm.add(bg, Const.DP_BG);
		bg.x = Const.GRID*12;
		bg.y = Const.GRID*5;

		dark = Assets.tiles.get("aptDark");
		Game.ME.sdm.add(dark, Const.DP_FRONT);
		dark.setPos(bg.x, bg.y);
	}

	override function onStateChange(?k) {
		super.onStateChange(k);

		if( k==null || k=="light1" )
			tw.create(dark.alpha, has("light1")?0:1);
	}


	override function unregister() {
		super.unregister();

		dark.dispose();
		dark = null;

		door.dispose();
		door = null;
	}


	override function update() {
		super.update();

		if( hero.xx>=310 )
			checkEnd();

		if( !has("light1") && hero.xx>=348 ) {
			hero.dx = -0.2;
			hero.dir = -1;
			g.say("I don't see a dawn thing there. I should turn on the light first.");
		}

		if( !has("light1") && hero.xx<=243 ) {
			hero.dx = 0.2;
			hero.dir = 1;
			g.say("I don't see a dawn thing there. I should turn on the light first.");
		}

		if( !has("light1") )
			Fx.ME.dot(260,141, 0x0080FF, 35);

		var l = dark.alpha;
		var ct = mt.deepnight.Color.getColorizeFilter(0x673AC5, l*0.3, 1-l*0.3);
		bg.filters = [ct];
	}
}