package sc;

import mt.deepnight.slb.*;
import mt.deepnight.Tweenie;

class Balcony extends Scene {
	var barrer		: BSprite;

	public function new() {
		super();

		id = "balcony";
		read("l_balcony");

		new Poi("A window", 256,105, 55,24)
			.look( function() {
				g.say([
					"A basic window, 2150 standard.",
					">I think there's someone inside.",
					"!>Naked, quite handsome but not my target tonight.",
				]);
			})
			.use( function() g.say("!>It's probably locked and there is someone inside... Are you some kind of perv?") );

		new Poi("A window", 345,118)
			.look( function() {
				g.say([
					">This one is closed. I think it looks inside the Target's apartment"
				]);
			})
			.use( function() g.say("!>Nope, it won't move...") );

		new Poi("A window", 475,117,30)
			.look( function() {
				g.say([
					">This one is closed. I think it looks inside the Target's apartment"
				]);
			})
			.use( function() g.say("!>It's locked, of course.") );

		new Poi("A broken light", 245,109)
			.look( function() {
				g.say("It's either broken or too dirty to diffuse any light.");
			})
			.use( function() g.say(">No time for patch-up job, I've someone to kill.") );

		new Poi("A broken light", 317,109)
			.look( function() {
				g.say("The glass is broken and there is no bulb inside.");
			});

		new Poi("Paint", 372,138)
			.look( function() {
				g.say([">A rat drowned inside.", ">\"Silver mist\". Nice color."]);
			});

		new Poi("Security pad", 440,123)
			.look( function() {
				if( !has("aunlocked") )
					g.say(["!The screen shows: LOCKED.", ">That's a quite advanced security measure if you ask me. The target must be stinking rich."]);
				else
					g.say(["The screen shows: UNLOCKED."]);
			})
			.use( function() {
				if( has("aunlocked") )
					g.say(">It's already open.");
				else if( foundItem("Access card") )
					g.say([">I must COMBINE my Access card with this pad."]);
				else
					g.say(["!>I can't force this one, and I hate to admit it.", ">I need a card or a multipass. Or a bomb."]);

			})
			.useWith( function(i) {
				if( i=="Access card" ) {
					set("aunlocked");
					Assets.SBANK.unlock(1);
					removeItem("Access card");
					g.say(["ACCESS GRANTED", ">Gotcha!"]);
					return true;
				}
				return false;
			});


		new Poi("Corridor light", 395,110)
			.use( function() {
				if( !foundItem("Access card") ) {
					cm.create({
						g.say(">You really expect the apartment key to be hidden here?") > end("pop");
						addItem("Access card");
						g.say([
							"You found an Access Card behind the light.",
							">Oh come on... This is SO cliche!"
						]);
					});
				}
				else
					g.say(">Sorry, we won't find every keys hidden behind a light.");
			})
			.look( function() g.say([
				">A large part of my job consists in turning lights off. Usually with a gun.",
			]) );

		new Poi("The city", 224,115)
			.look( function() g.say(["This City is what it is because our citizens are what they are. Assholes."]) );

		new Poi("Target's apartment", 424,123)
			.look( function() g.say([">Nice view from here, the rent must be quite obscene."]) )
			.use( function() {
				if( has("aunlocked") )
					transition( function() new sc.Apartment() );
				else
					g.say(["!>Guess what? It's locked. I hate when this happens.",">There is a security pad on the right."]);
			});
			//.use( function() g.say([">What the fuck?!","!>The door is locked from inside!","You knock at the door, but no one replies..."]) );



		var engine = Assets.SBANK.carLoop();
		function _arrive() {
			engine.tweenVolume(0.10, 2000);
			var s = Assets.SBANK.carArrive().play(0,-1);
			s.tweenVolume(1,1500);
			s.tweenPanning(0,1000);
		}
		function _leave() {
			engine.tweenVolume(0, 1000);
			var s = Assets.SBANK.carLeave().play(0,0);
			s.tweenVolume(1,1500);
			s.tweenPanning(1,2000);
		}



		if( cameFrom("apartment") )
			hero.setPosCase(26,8);
		else {
			// Arrival cinematic
			hero.setPosCase(16,8);
			#if !debug
			var car = Assets.tiles.get("car");
			Game.ME.sdm.add(car, Const.DP_FRONT);
			car.setCenter(0.5,1);
			var ds = 0.;
			tw.create(ds,800|1,600).onUpdateT = function(t) {
				car.filters = [
					new flash.filters.DropShadowFilter(16*t,50, 0x0,0.4*t, 0,0),
				];
			}
			car.filter = false;
			car.scaleX = -1;
			var x = -100;
			var y = hero.yy;
			locked = true;
			hero.spr.visible = false;
			var p = createTinyProcess( function(_) {
				car.x = Std.int( x + Math.sin(time*0.06)*5 );
				car.y = Std.int( y + 15 + Math.cos(time*0.1)*2 );
			}, true);
			function _tuto1() {
				if( !ui.TutorialMsg.hasDone("skip") )
					new ui.TutorialMsg("skip", "SPACE to skip message", 264,149);
			}
			function _tuto2() new ui.TutorialMsg("move", "Use ARROWS to walk", 264,149);
			engine.playLoop();
			engine.setVolume(0);
			cm.create({
				tw.create(car.rotation, -5, 800).onEnd = function() {
					tw.create(car.rotation, 0, 800);
				}
				_arrive();
				tw.create(x, hero.xx, 1500, TEaseOut).onEnd = function() cm.signal();
				end;
				500;
				hero.spr.visible = true;
				tw.create(y, y+3, 200, TLoop).onEnd = function() cm.signal(); end;
				tw.create(y, y-4, 300, TLoop).onEnd = function() cm.signal(); end;
				locked = false;
				500;
				_leave();
				tw.create(x, hero.xx+600, 1500, TEaseOut).onEnd = car.dispose;
				500;
				600>>_tuto1();
				1000>>Assets.music.playLoop();
				g.say(">So. Basically, they asked me to kill this guy. What was his name again?") > end;
				ui.TutorialMsg.clear("skip");
				g.say("!>Oh well, who cares. He is dead meat to me anyway.") > end;
				g.say(">The thing is they want him dead in an... UNCONVENTIONAL way.") > end;
				g.say("!>What the fuck did they mean by 'unconventional'?") > end;
				g.say(">But Ludum-Tek pays well, so I guess I'll have to find a way to deal with this corpo bullshit.") > end;
				500>>_tuto2();
				end;
				engine.stop();
				p.destroy();
			});
			#end
		}


		// End scene
		if( objectiveComplete() ) {
			locked = true;

			var car = Assets.tiles.get("car");
			Game.ME.sdm.add(car, Const.DP_FRONT);
			car.setCenter(0.5,1);
			var ds = 0.;
			tw.create(ds,800|1,600).onUpdateT = function(t) {
				car.filters = [
					new flash.filters.DropShadowFilter(16*t,50, 0x0,0.4*t, 0,0),
				];
			}
			car.filter = false;
			car.scaleX = -1;
			var x = -100;
			var y = hero.yy;
			var p = createTinyProcess( function(_) {
				car.x = Std.int( x + Math.sin(time*0.06)*5 );
				car.y = Std.int( y + 15 + Math.cos(time*0.1)*2 );
			}, true);

			var t = new en.Target(15,8);
			t.spr.visible = false;

			var line = 0;
			function _credit(s) {
				new ui.TutorialMsg("credit"+line, s, 8,104+line*10, 1);
				line++;
			}
			function _surprise() {
				Fx.ME.surprise(t);
				t.handsUp(true);
				t.dx = -0.1;
				t.dy = -0.1;
			}

			cm.create({
				300;
				hero.goto(492)>end;
				hero.dir = -1;
				1200;
				hero.setCrouch(true);
				1500;
				g.say(">I guess I still have enough time for another cigaret.")>end;
				Game.ME.tw.create( Game.ME.root.alpha, 0, TLoop, 2500).onEnd = function() cm.signal();
				end;

				// Car
				_arrive();
				tw.create(x, 263, 1500, TEaseOut).onEnd = function() cm.signal();
				end;
				500;
				t.spr.visible = true;

				t.goto(412)>end;
				g.say(">Good evening mister... er...")>end;
				300;
				hero.setCrouch(false);
				150;
				hero.dir = 1;
				g.say(">Damn. What its name again?")>end;
				300;
				hero.dir = -1;
				200;
				hero.setCrouch(false);
				300;
				hero.setCombat(true);
				700>>_surprise();
				g.say(">!Ah fuck that shit! Who cares anyway?")>end;
				g.say(">!GO INSIDE RIGHT NOW BEFORE I CHANGE MY MIND AND SHOOT YOU IN A MORE CONVENTIONAL WAY!!")>end;
				tw.create(t.spr.alpha, 0, 1000);
				t.goto(424)>end;
				600;
				hero.setCombat(false);
				700;
				g.say(">Now, you'll die within one week or two.")>end;
				500;
				g.say(">...I hope that's \"original\" enough for my client.")>end;
				400;
				unset("aunlocked");
				500;
				g.say("!DOOR LOCKED.")>end;
				hero.goto(384)>end;
				600;
				hero.goto(360)>end;
				1500;
				g.say(">Seriously.")>end;
				300;
				hero.dir = 1;
				100;
				g.say(">!That's the shitiest contract I've ever done.")>end;
				1000;
				hero.dir = -1; 1500;
				hero.dir = 1; 1500;
				g.say(">Ah... Fuck.")>end;
				200>>set("aunlocked");
				700>>tw.create(hero.spr.alpha, 0, 1000);
				hero.goto(422)>end;
				hero.spr.visible = false;
				2000;
				g.say(">Groom service!")>end;
				500;
				Assets.SBANK.lazer2(0.3);
				Fx.ME.blink(0xFF0000,0.3, 0.5);
				300;
				Assets.SBANK.lazer2(0.5);
				Fx.ME.blink(0xFF0000,0.4, 0.5);
				1000;
				hero.spr.visible = true;
				tw.create(hero.spr.alpha, 1, 800);
				hero.goto(395)>end;
				g.say(">Old school methods are way better.")>end;
				hero.goto(263)>end;
				g.say(">Damn, I really love my job.")>end;
				hero.spr.visible = false;
				_leave();
				tw.create(x, x+500, 2700).onEnd = function() {
					car.dispose();
					cm.signal();
				}
				end;

				Game.ME.cd.set("credits",99999);
				500;
				_credit("Thank you for playing!"); 1000;
				_credit("A 48h game by Sebastien Benard"); 2000;
				_credit("TWITTER: deepnightFR"); 1000;
				_credit("WEB: www.deepnight.net"); 1000;
			});
		}
	}


	override function draw() {
		super.draw();

		bg = Assets.tiles.get("s_balcony");
		Game.ME.sdm.add(bg, Const.DP_BG);

		barrer = Assets.tiles.get("barrer");
		Game.ME.sdm.add(barrer, Const.DP_FRONT);
		barrer.setCenter(0,1);
		barrer.setPos(224,144);
	}

	override function unregister() {
		super.unregister();
		barrer.dispose();
	}


	override function update() {
		super.update();
		Game.ME.fx.dust();

		if( hero.xx>=280 ) {
			ui.TutorialMsg.clear("move");
			if( !ui.TutorialMsg.hasDone("use") )
				new ui.TutorialMsg("use", "SPACE to interact", 264,149);
		}

		if( has("aunlocked") )
			Fx.ME.dot(439,123, 0x80FF00, 15);
		else
			Fx.ME.dot(439,123, 0xFF0000, 15);

		if( time%10==0 ) {
			Game.ME.fx.cars(20,230,hei*0.5, 1);
			Game.ME.fx.cars(20,230,hei*0.5+5, -1);
			Game.ME.fx.cars(20,210,hei*0.3, 1);
		}
	}
}