package sc;

import mt.deepnight.slb.*;

class Bathroom extends Scene {
	var pills		: BSprite;
	var trap		: BSprite;

	public function new() {
		super();

		#if debug
		set("item_Knife");
		set("item_Small key");
		#end

		id = "bathroom";
		read("l_bathroom");
		Game.ME.hero.setPosCase(20,9, 1);

		new Poi("Exit", 296,141)
			.use( function() {
				transition( function() new sc.Apartment() );
			});

		new Poi("Toilet bowl", 347,152)
			.look( function() g.say(">Surprisingly, it's absolutely clean.") )
			.use( function() g.say(">That's definitely not the time for that.") );

		new Poi("Washbassin", 363,143)
			.look( function() g.say(">Someone used it recently to shave.") )
			.use( function() g.say([">If I planned to kill my target using its hair and a voodoo doll, that would work.", ">!But I'm not THAT unconventional."]) );

		new Poi("Auto-Shower", 387,139)
			.look( function() g.say([">That's a VERY expensive equipment... If only I had one.",">Oh wait. I HAVE one."]) )
			.use( function() g.say(">I must kill the guy first.") );

		new Poi("Pharmacy", 332,150)
			.look( function() g.say([">Hundreds of tablets and pills."]) )
			.use( function() {
				if( has("punlocked") ) {
					if( !foundItem("Constipation pills") )
						cm.create({
							g.say("You immediatly notice an interesting medicine: Constipation pills.") > end;
							g.say(">Smalls pills, great fun.") > end;
							addItem("Constipation pills");
							removePoi("Constipation pills");
							pills.visible = false;
							g.say(">I'm sure those pills will be very useful. You know, for the \"unconventional\" thing.")>end;
						});
					else
						g.say(">Nothing interesting. I already picked the best medicine from it.");
				}
				else
					g.say("!It's locked.");
			})
			.useWith(function(i) {
				if( i=="Small key" ) {
					removeItem("Small key");
					set("punlocked");
					g.say("You open the pharmacy.");
					return true;
				}
				return false;
			});

		new Poi("Fuses", 317,150)
			.look( function() {
				g.say(">All the circuits that control the doors and the windows. If you want to kill someone, that's probably a nice place to begin with.");
			})
			.use( function() {
				if( has("fuseOpen") ) {
					if( !has("sabotageDoor") ) {
						cm.create({
							if( mt.MLib.fabs(hero.xx-306)>=6 ) {
								hero.goto(306)>end;
								150;
								hero.dir = 1;
								150;
								hero.setCrouch(true);
								500;
							}
							Fx.ME.blink(0x0080FF,1);
							Assets.SBANK.explode1(0.35);
							Fx.ME.shake(1,30);
							set("sabotageDoor");
							g.say("You modified the circuits so only you will be able to open and close doors and windows.");
							locked = false;
						});
					}
					else {
						g.say("The doors are already under your control.");
					}
				}
				else
					g.say(">I need a screwdriver or something to open this trapdoor.");
			})
			.useWith( function(i) {
				if( i=="Knife" ) {
					locked = true;
					cm.create({
						hero.goto(306)>end;
						150;
						hero.dir = 1;
						150;
						hero.setCrouch(true);
						removeItem("Knife");
						set("fuseOpen");
						g.say(["You quickly open the trapdoor using the knife."])>end;
						200;
						trap.visible = true;
						Assets.SBANK.kick3(0.7);
						300;
						g.say([">NOW, we can talk."])>end;
						locked = false;
					});
					return true;
				}
				return false;
			});

		trap = Assets.tiles.get("fuse");
		Game.ME.sdm.add(trap, Const.DP_BG);
		trap.setPos(314,145);
		trap.visible = has("fuseOpen");

		if( !foundItem("Constipation pills") ) {
			pills = Assets.tiles.get("pills");
			Game.ME.sdm.add(pills, Const.DP_BG);
			pills.setCenter(0.5,1);
			pills.setPos(334,142);
		}
			//new Poi("Constipation pills", 367,142)
				//.look( function() g.say(">Smalls pills, great fun.") )
				//.use( function() {
					//addItem("Constipation pills");
					//g.say(">I'm sure those pills will be very useful. You know, for the \"unconventional\" thing.");
					//removePoi("Constipation pills");
					//pills.dispose();
					//pills = null;
				//});
		//}

		if( !hasSet("bathAssault") ) {
			var e = new en.Cop(22,9, 2);
			locked = true;
			cm.create({
				hero.dir = 1;
				600;
				400>>hero.setCombat(true);
				800>>Fx.ME.surprise(e);
				900>>e.setCrouch(true);
				g.say("Groom service!") > end;
				200>>hero.setCrouch(true);
				locked = false;
			});
		}



		hero.setPosCase(18,9);
	}

	override function onCombatEnd() {
		super.onCombatEnd();
	}

	override function unregister() {
		super.unregister();
		if( pills!=null ) {
			pills.dispose();
			pills = null;
		}
	}


	override function draw() {
		super.draw();

		bg = Assets.tiles.get("s_bathroom");
		Game.ME.sdm.add(bg, Const.DP_BG);
		bg.x = Const.GRID*18;
		bg.y = Const.GRID*5;
	}

	override function update() {
		super.update();
	}
}