package ui;

import mt.MLib;
import mt.deepnight.Lib;
import flash.display.Sprite;

class Menu extends mt.deepnight.FProcess {
	public static var CURRENT : Menu;

	//var label				: flash.text.TextField;
	public var active		: Int;
	var buttons				: Array<{s:Sprite, cb:Void->Void}>;
	var large				: Bool;
	//var snap				: Null<flash.display.Bitmap>;
	//var mask				: flash.display.Sprite;

	public function new(?p:Poi, ?large=false) {
		super(Game.ME);

		this.large = large;
		name="menu "+large;
		Assets.SBANK.dialog3(0.6);

		Game.ME.sdm.add(root, Const.DP_UI);
		active = 0;
		CURRENT = this;
		buttons = [];

		root.x = Game.ME.hero.xx+300;
		root.y = Game.ME.hero.yy;
	}

	public function close() {
		active = -1;
		updateActive();
		tw.create(root.alpha, 150|0, 200);
		tw.create(root.scaleX, 150|0, 200).onEnd = function() {
			destroy();
		}
		tw.create(root.scaleY, 0.1, 150);

		if( CURRENT==this )
			CURRENT = null;
	}

	override function unregister() {
		super.unregister();

		buttons = null;

		if( CURRENT==this )
			CURRENT = null;
	}

	public function prev() {
		if( active>0 )
			Assets.SBANK.dialog3(0.2);
		active--;
		active = MLib.clamp(active, 0,buttons.length-1);
		updateActive();
		//if( active<0 )
			//active = buttons.length-1;
	}

	public function next() {
		if( active<buttons.length-1 )
			Assets.SBANK.dialog3(0.2);
		active++;
		active = MLib.clamp(active, 0,buttons.length-1);
		updateActive();
		//if( active>=buttons.length )
			//active = 0;
	}

	public function addButton(label:String, cb:Void->Void) {
		var w = new flash.display.Sprite();
		root.addChild(w);

		var bg = new flash.display.Sprite();
		w.addChild(bg);
		bg.graphics.beginFill(0x187C92,1);
		bg.graphics.drawRect(0,0,large?120:65,9);
		bg.filters = [
			new flash.filters.DropShadowFilter(5, -90, 0x0,0.15, 0,0,1, 1,true),
			new flash.filters.GlowFilter(0x36BAC9,1, 2,2,10),
			new flash.filters.GlowFilter(0x051B1F,1, 2,2,8),
		];

		var tf = Assets.createField(label);
		w.addChild(tf);
		tf.y = -1;

		w.alpha = 0;
		tw.create(w.alpha, buttons.length*100|0>1, 300);
		tw.create(w.x, buttons.length*100|20>0, 200).pixel = true;

		buttons.push({ s:w, cb:cb });
		rebuild();
	}

	function rebuild() {
		var y = 0.;
		for(b in buttons) {
			b.s.y = y;
			y+=b.s.height;
		}

		//if( snap!=null ) {
			//snap.y = y*0.5 - snap.height*0.5 - 2;
			//label.x = Std.int( snap.x + snap.width*0.5 - label.width*0.5 );
			//label.y = snap.y + 1;
		//}

		updateActive();
	}

	public function confirm() {
		Assets.SBANK.menu3(0.4);
		buttons[active].cb();
		close();
	}

	function updateActive() {
		var i = 0;
		for(b in buttons) {
			if( i==active ) {
				b.s.parent.setChildIndex(b.s, b.s.parent.numChildren-1);
				b.s.filters = [
					new flash.filters.GlowFilter(0xFFFFFF,1, 2,2,8, 1,true),

					new flash.filters.GlowFilter(0x48ACF7,1, 4,2,2),
					new flash.filters.GlowFilter(0x108DD8,0.6, 16,8,2),
				];
			}
			else
				b.s.filters = [];
			i++;
		}
	}

	override function update() {
		super.update();
		var e = Game.ME.hero;
		var x = e.xx + 30;
		var y = e.yy - Const.GRID - root.height*0.5;
		if( x + Game.ME.scroller.x>=Game.ME.buffer.width-100 )
			x = e.xx - root.width-30;
		root.x += (x-root.x)*0.5;
		root.y += (y-root.y)*0.5;
		root.x = Std.int( root.x );
		root.y = Std.int( root.y );

		//mask.x = -Game.ME.scroller.x;
		//mask.y = -Game.ME.scroller.y;
	}
}