package ui;

import mt.MLib;
import mt.deepnight.Lib;
import mt.deepnight.Color;
import flash.display.Sprite;

class TutorialMsg extends mt.deepnight.FProcess {
	static var ALL : Array<TutorialMsg> = [];

	public var id		: String;

	public function new(id:String, str:String, x:Float,y:Float, ?scale=2) {
		super(Game.ME);

		ALL.push(this);
		this.id = id;
		Scene.FLAGS.set("tuto_"+id,1);

		Game.ME.sdm.add(root, Const.DP_FX);

		var tf = Assets.createField(str, 0xFFC600);
		root.addChild(tf);
		tf.scaleX = tf.scaleY = scale;
		tf.filters = [
			new flash.filters.GlowFilter(0xFF7900,0.8, 32,32,2, 2),
		];

		root.x = Std.int( x );
		root.y = Std.int( y );
		root.blendMode = ADD;

		tw.create(root.alpha, 0>1, 800);
	}

	public static function hasDone(id:String) return Scene.FLAGS.exists("tuto_"+id);
	public static function complete(id:String) return Scene.FLAGS.set("tuto_"+id,1);

	public static function clearAll() {
		for(e in ALL.copy())
			e.hide();
	}

	public static function clear(id:String)	 {
		for( e in ALL.copy() )
			if( e.id==id )
				e.hide();
	}

	public function hide() {
		if( ALL.remove(this) ) {
			tw.create(root.alpha, 0, 600).onEnd = function() {
				destroy();
			}
		}
	}


	override function unregister() {
		super.unregister();

		ALL.remove(this);
	}

	override function update() {
		super.update();
	}
}